unit UXDBTable;

//**********************************************************
//W : TXDBTable For AspFileDB Suit
//s@ : 2003/12/20
//s@ʾ : αAspFileDB Suit To Standard VCL DB Controls
//gH(@) :Ying-Cheng Lin (G01 in KTOP Site)
//     : Beta 1.0
//SOn : Only Share To Delphi KTop Members !!
//           Фnoǻr,Kis!!
//---------------------HUק-----------------------
//קH :Ying-Cheng Lin (G01 in KTOP Site)
//ק :2004/01/09 - 2004/01/10
//ק] :s/sW/ק/R,ƫеoͰD!!
//קؼ :եTDataSet Cursorm,åBTAspFileDataSet
//ק:
//        1.sWPtivateܼ:
//            IsInRefreshState:boolean;//P_O_bRefresh A
//            IsInEditState   :boolean;//P_O_bEdit    A
//            IsInInsertState :boolean;//P_O_bInsert  A
//        2.ק禡
//            GetFieldData
//            GetRecord
//            GetRecNo
//            InternalOpen
//            InternalPost
//        3.sW禡
//            GetFieldDataStartIDInDataStr
//            InternalInsert
//            InternalEdit
//            InternalCancel
//s : Beta 2.0
//**********************************************************

interface                  

uses
  SysUtils, Classes, DB,DBTables,Forms,Dialogs,UAspFileDataset,
  DesignIntf,DesignEditors;

type

  //*********FKMTDataSetOX@,ҥHwqXHUƵc***********
  TVCLMemDataPage = string[255];
  PTXDBBookMarkInfo = ^TXDBBookMarkInfo;
  TXDBBookMarkInfo = record
    BookMarkData:integer;
    BookMarkFlag:TBookMarkFlag;
  end;
  PTXDBNode = ^TXDBNode;
  TXDBNode = record
    XDBDataCursor:integer;
    MetaData    :array[1..13] of TVCLMemDataPage;
  end;
  //************************************************************************
  TXDBFileStr  = type String;
  TXDBFileName = class(TStringProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
  end;
  //HUOڭ̪D
  TXDBTable = class(TDataSet)
  private
    RealXDBDataSize :integer;//ϥܼ
    IsInRefreshState:boolean;//ϥܼ
    IsInEditState   :boolean;//ϥܼ
    IsInInsertState :boolean;//ϥܼ
    FCacheUpdate    :boolean;
    FReadOnly       :boolean;
    FData           :TAspFileDataSet;
    FRecSize        :Integer;
    FRecBufSize     :Integer;
    FCurRec         :Integer;
    FFileName       :TXDBFileStr;
    FUserName       :string;
    FSaveChanges    :boolean;         
    procedure SetFReadOnly(const Value: boolean);
    procedure SetFCacheUpdate(const Value: boolean);
    function  GetFieldDataStartIDInDataStr(FdName:string):integer;
  protected
    //DataSnap ( MIDAS ) Support !!
    function  PSUpdateRecord(UpdateKind: TUpdateKind; Delta: TDataSet): Boolean; override;
  protected
    function  AllocRecordBuffer: PChar; override;
    procedure FreeRecordBuffer(var Buffer: PChar); override;
    procedure GetBookmarkData(Buffer: PChar; Data: Pointer); override;
    function  GetBookmarkFlag(Buffer: PChar): TBookmarkFlag; override;
    function  GetFieldData(Field: TField; Buffer: Pointer): Boolean; override;
    function  GetRecordCount: Integer; override;
    function  GetRecord(Buffer: PChar; GetMode: TGetMode; DoCheck: Boolean): TGetResult; override;
    function  GetRecordSize: Word; override;
    function  GetCanModify: Boolean; override;
    procedure InternalAddRecord(Buffer: Pointer; Append: Boolean); override;
    procedure InternalRefresh; override;
    procedure InternalCancel; Override;
    procedure InternalClose; override;
    procedure InternalEdit; override;
    procedure InternalDelete; override;
    procedure InternalFirst; override;
    procedure InternalLast; override;
    procedure InternalInsert; override;
    procedure InternalGotoBookmark(Bookmark: Pointer); override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalInitRecord(Buffer: PChar); override;
    procedure InternalOpen; override;
    procedure InternalPost; override;
    procedure InternalSetToRecord(Buffer: PChar); override;
    function  IsCursorOpen: Boolean; override;
    procedure SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag); override;
    procedure SetBookmarkData(Buffer: PChar; Data: Pointer); override;
    procedure SetFieldData(Field: TField; Buffer: Pointer); override;
    function  GetRecNo: Integer; override;
    procedure SetRecNo(Value: Integer); override;
  public
    Constructor Create(AOwner: TComponent); override;
    Destructor  Destroy; override;                    
    function    FindData(const KeyFields,KeyValues: array of Variant): Boolean;
    procedure   ApplyUpdates; 
  published
    property CacheUpdate:boolean read FCacheUpdate write SetFCacheUpdate;
    property FileName :TXDBFileStr read FFileName write FFileName;
    property UserName:string read FUserName write FUserName;
    property DataSetField;

    property ReadOnly:boolean read FReadOnly write SetFReadOnly;

    property FieldDefs;
    property Filter;
    property Filtered;
    property Active;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnNewRecord;
    property OnPostError;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterPropertyEditor( TypeInfo(TXDBFileStr),nil,'',TXDBFileName);
  RegisterComponents('AspFileDBSuit', [TXDBTable]);
end;

//*********FKMTDataSetOX@,ҥHwqXHUƵcBz禡***********
function GetPageStrInString(EachPageSize,PageNo:integer;inStr:string):string;
var StartCharNo,EndCharNo,i:integer;
    inStrSize:integer;
    rStr:string;
begin
  result := ''; rStr := '';
  if(inStr = '')then Exit;
  if(PageNo = 0)then Exit;
  StartCharNo := EachPageSize*(PageNo-1)+1;
  EndCharNo   := StartCharNo+EachPageSize-1;
  inStrSize   := Length(inStr);
  for i := StartCharNo to EndCharNo do
    if(i <= inStrSize)then rStr := rStr+instr[i]
    else Break;
  Result := rStr;
end;

procedure PutDataStrToPageArray(var dataPage:TXDBNode;inStr: string;
                                CursorInfo:integer);
var strSize:integer;
    haveData:boolean;
    function DataToPage(pgno:integer):boolean;
    begin
      result := FALSE;
      dataPage.MetaData[pgno]
       := GetPageStrInString(255,pgno,inStr);
      if(Length(dataPage.MetaData[pgno]) > 0)then result := TRUE;
    end;
begin
  dataPage.XDBDataCursor := CursorInfo;
  dataPage.MetaData[ 1] := '';
  dataPage.MetaData[ 2] := '';
  dataPage.MetaData[ 3] := '';
  dataPage.MetaData[ 4] := '';
  dataPage.MetaData[ 5] := '';
  dataPage.MetaData[ 6] := '';
  dataPage.MetaData[ 7] := '';
  dataPage.MetaData[ 8] := '';
  dataPage.MetaData[ 9] := '';
  dataPage.MetaData[10] := '';
  dataPage.MetaData[11] := '';
  dataPage.MetaData[12] := '';
  dataPage.MetaData[13] := '';
  strSize := Length(inStr);
  if(strSize <= 255)then dataPage.MetaData[1] := inStr
  else        
    begin
      haveData := DataToPage(1);
      if(haveData = TRUE)then haveData := DataToPage( 2);
      if(haveData = TRUE)then haveData := DataToPage( 3);
      if(haveData = TRUE)then haveData := DataToPage( 4);
      if(haveData = TRUE)then haveData := DataToPage( 5);
      if(haveData = TRUE)then haveData := DataToPage( 6);
      if(haveData = TRUE)then haveData := DataToPage( 7);
      if(haveData = TRUE)then haveData := DataToPage( 8);
      if(haveData = TRUE)then haveData := DataToPage( 9);
      if(haveData = TRUE)then haveData := DataToPage(10);
      if(haveData = TRUE)then haveData := DataToPage(11);
      if(haveData = TRUE)then haveData := DataToPage(12);
      if(haveData = TRUE)then haveData := DataToPage(13);
    end;//else...end!!
end;
//****************************************************************************

Constructor TXDBTable.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.FData := TAspFileDataset.Create(nil);
  self.FData.AccessFile := self.FFileName;
  self.FData.AccessUser := self.UserName;
  self.FRecSize    := SizeOf(TXDBNode);
  self.FRecBufSize := self.FRecSize+SizeOf(TXDBBookMarkInfo);
end;

Destructor TXDBTable.Destroy;
begin
  if(self.FData <> nil)then
    begin
      self.FData.Active     := FALSE;
      self.FData.AccessFile := '';
      self.FData.Free;
      self.FData := nil;
    end;//if...end!!
  inherited Destroy;
end;

procedure TXDBTable.InternalOpen;
begin
  if(self.FData = nil)then Exit;
  self.FData.Active := FALSE;
  self.FData.AccessUser := self.FUserName;
  self.FData.AccessFile := Self.FFileName;
  self.FData.Active := TRUE;
  if(self.FData.FieldCount > 0)then
    begin
      // Initializing field definitions and field creation (TFields)
      InternalInitFieldDefs;
      if(DefaultFields)then CreateFields;
      BindFields(True);
    end;//if...end!!
  self.FCurRec := self.FData.GetBookMark;
  self.IsInEditState    := FALSE;
  self.IsInInsertState  := FALSE;
  self.IsInRefreshState := FALSE;
end;

procedure TXDBTable.InternalClose;
begin
  if(DefaultFields)then self.DestroyFields;
  if(self.FData <> nil)then
    begin
      self.FData.Active  := FALSE;
      self.FData.AccessFile     := '';
      self.FData.SchemaFileName := '';
    end;//if...end!!  
  self.FCurRec := -1;
end;

function TXDBTable.IsCursorOpen: Boolean;
begin
  if(self.FData = nil)then Exit;
  Result := Assigned(self.FData)and(self.FData.FieldCount > 0);
end;

procedure TXDBTable.InternalInitFieldDefs;
var i,ds:integer;
    str:string;
begin
  if(self.FData = nil)then Exit;
  self.RealXDBDataSize := 0;
  self.FieldDefs.Clear;
  for i := 0 to self.FData.FieldCount-1 do
    begin
      str := self.FData.FieldName(i);
      ds  := self.FData.FieldDataSize(str);
      TFieldDef.Create( FieldDefs
                       ,str
                       ,ftString
                       ,ds
                       ,self.FData.IsKeyField(str)
                       ,i);
      self.RealXDBDataSize := self.RealXDBDataSize+ds;
    end;//for...i..end!!
end;

procedure TXDBTable.InternalHandleException;
begin
  Application.HandleException(Self);
end;

//BookMarks.
procedure TXDBTable.InternalGotoBookmark(Bookmark: Pointer);
var Index:Integer;
begin
  Index := Integer(Bookmark^);
  if(Index <> -1)then
    begin
      self.FData.GotoBookMark(Index);
      self.FCurRec := self.FData.GetBookMark;
    end;
end;

procedure TXDBTable.InternalSetToRecord(Buffer: PChar);
begin
  InternalGotoBookmark(@PTXDBBookMarkInfo(Buffer + Self.FRecSize)^.BookmarkData);
end;

function TXDBTable.GetBookmarkFlag(Buffer: PChar): TBookmarkFlag;
begin
  Result := PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkFlag;
end;

procedure TXDBTable.SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag);
begin
  PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookmarkFlag := Value;
end;

procedure TXDBTable.GetBookmarkData(Buffer: PChar; Data: Pointer);
begin
  Integer(Data) := PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkData;
end;

procedure TXDBTable.SetBookmarkData(Buffer: PChar; Data: Pointer);
begin
  PTXDBBookMarkInfo(Buffer + self.FRecSize)^.BookMarkData := Integer(Data);
end;

function TXDBTable.GetRecordSize: Word;
begin
  Result := self.FRecSize;
end;

function TXDBTable.AllocRecordBuffer: PChar;
begin
  //tmC@recordһݪBufferjp
  GetMem(Result,self.FRecBufSize);
end;

procedure TXDBTable.FreeRecordBuffer(var Buffer: PChar);
begin
  FreeMem(Buffer,self.FRecBufSize);
end;

function TXDBTable.GetRecord(Buffer: PChar; GetMode: TGetMode;
                    DoCheck: Boolean): TGetResult;
var UseRecordCount:integer;
    DataStr:string;
    function GetActiveBufferDataStr:string;
    var rstr:string;
    begin
      rstr := PTXDBNode(self.ActiveBuffer)^.MetaData[ 1]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 2]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 3]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 4]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 5]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 6]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 7]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 8]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[ 9]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[10]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[11]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[12]
             +PTXDBNode(self.ActiveBuffer)^.MetaData[13];
      result := rstr;      
    end;

    procedure ClearBuffer;
    begin
      PTXDBNode(Buffer)^.XDBDataCursor := -1;
      PTXDBNode(Buffer)^.MetaData[ 1] := '';
      PTXDBNode(Buffer)^.MetaData[ 2] := '';
      PTXDBNode(Buffer)^.MetaData[ 3] := '';
      PTXDBNode(Buffer)^.MetaData[ 4] := '';
      PTXDBNode(Buffer)^.MetaData[ 5] := '';
      PTXDBNode(Buffer)^.MetaData[ 6] := '';
      PTXDBNode(Buffer)^.MetaData[ 7] := '';
      PTXDBNode(Buffer)^.MetaData[ 8] := '';
      PTXDBNode(Buffer)^.MetaData[ 9] := '';
      PTXDBNode(Buffer)^.MetaData[10] := '';
      PTXDBNode(Buffer)^.MetaData[11] := '';
      PTXDBNode(Buffer)^.MetaData[12] := '';
      PTXDBNode(Buffer)^.MetaData[13] := '';
    end;
    //=====================================================
    function GetRepareData:string;
    var i,fdofs,dataLength:integer;
        fstr,str,rstr:string;
    begin
      fdofs := 1; rstr := '';
      for i := 0 to self.FData.FieldCount-1 do
        begin
          str  := '';
          fstr := self.FData.FieldName(i);
          dataLength := self.FData.FieldDataSize(fstr);
          str := str+self.FData.FieldByName(fstr).AsString;
          while(Length(str) < dataLength)do
            str := str+' ';
          rstr := rstr+str;
        end;//for...i...end!!
      result := rstr;
    end;
    //=====================================================
begin
  //-------------------------------------------------------------
  //`N!!
  //1.oFunction Ib,'ʻPP_Cursor';
  //  o|vT줺ƶ󪺹ڸƫ!!
  //EX.
  //    self.FData.RecDataSet.CursorPriorRecord
  //   άO self.FData.RecDataSet.CursorNextRecord
  //        self.FData.RecDataSet.CursorIsBof
  //        self.FData.RecDataSet.CursorIsEof
  //        self.FData.RecDataSet.CursorGoToBookMark
  //   ӨNHUO
  //        self.FData.Prior
  //        self.FData.Next        
  //        self.FData.IsBof
  //        self.FData.IsEof
  //        self.FData.GoToBookMark
  // ϥCursorCOتNOb
  // βʸ,ovTTAspFileDataSet(sW/ק)A   
  //-------------------------------------------------------------
  if(self.FData = nil)then Exit;
  //======oDataSet䴩RefreshO!!======
  if(self.IsInRefreshState = TRUE)or(self.IsInEditState = TRUE)then
    begin
      self.IsInEditState    := FALSE;
      self.IsInRefreshState := FALSE;
      self.FData.GotoBookMark(self.FCurRec);
      Abort;
    end;//if...end!! 
  //==========================================
  UseRecordCount := RecordCount;
  if(UseRecordCount <= 0)then Result := grEOF
  else
    begin
      Result  := grOK;
      case GetMode of
        gmPrior:begin
                  if(self.FData.RecDataSet.CursorIsBof = TRUE)then
                    begin
                      if(self.IsInInsertState = TRUE)then
                        begin
                          self.IsInInsertState := FALSE;
                          DataStr := '';
                          DataStr := GetRepareData;
                          //****************************************************
                          ClearBuffer;
                          PutDataStrToPageArray( PTXDBNode(Buffer)^,DataStr,
                                                self.FData.GetBookMark);
                          PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkData
                            := self.FCurRec;
                          PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkFlag
                            := bfCurrent;
                          //****************************************************
                          Result := grBOF;
                        end//if...end!!
                      else
                        begin
                          DataStr := '';
                          DataStr := GetRepareData;
                          if(GetActiveBufferDataStr = DataStr)then
                            Result := grBOF
                          else self.FCurRec := self.FData.GetBookMark;
                        end;//else...end!!
                    end//if...end!!
                  else
                    begin
                      self.FCurRec := self.FData.GetBookMark;
                      DataStr := '';
                      DataStr := GetRepareData;
                      self.FData.RecDataSet.CursorPriorRecord;
                      if(GetActiveBufferDataStr = DataStr)then
                       begin
                         self.FCurRec := self.FData.GetBookMark;
                         DataStr := '';
                         DataStr := GetRepareData;
                         self.FData.RecDataSet.CursorPriorRecord;
                       end;//if...end!!
                    end;//if...end!!
                end;
        //=============================================================
        gmCurrent: begin
                     if(self.FCurRec <= 0)or(self.FCurRec > UseRecordCount)then
                       Result := grError
                     else   //R/sWƫ,|ӳo̧!!
                       begin
                         self.FData.RecDataSet.CursorGoToBookMark(self.FCurRec);
                         DataStr := '';
                         DataStr := GetRepareData;
                       end;//else...end!!
                   end;
        //=============================================================
        gmNext:begin
                 if(self.FData.RecDataSet.CursorIsEof = TRUE)then
                   begin
                     DataStr := '';
                     DataStr := GetRepareData;
                     if(GetActiveBufferDataStr = DataStr)then
                       Result := grEOF
                     else self.FCurRec := self.FData.GetBookMark;
                   end//if...end!!
                 else
                   begin
                     self.FCurRec := self.FData.GetBookMark;
                     DataStr := '';
                     DataStr := GetRepareData;
                     self.FData.RecDataSet.CursorNextRecord;
                     if(GetActiveBufferDataStr = DataStr)then
                       begin
                         self.FCurRec := self.FData.GetBookMark;
                         DataStr := GetRepareData;
                         self.FData.RecDataSet.CursorNextRecord;
                       end;//if...end!!


                   end;
               end;
      end;//case...end!!
      if(Result = grOK)then
        begin
          if(DataStr <> '')then
            begin
              ClearBuffer;
              PutDataStrToPageArray(PTXDBNode(Buffer)^,DataStr,self.FData.GetBookMark);
              PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkData := self.FCurRec;
              PTXDBBookMarkInfo(Buffer+Self.FRecSize)^.BookMarkFlag := bfCurrent;
            end;//if...end!!
        end;//if...end!!
    end;//else...end!!
end;

procedure TXDBTable.InternalInitRecord(Buffer: PChar);
begin
  PTXDBNode(Buffer)^.MetaData[ 1] := '';
  PTXDBNode(Buffer)^.MetaData[ 2] := '';
  PTXDBNode(Buffer)^.MetaData[ 3] := '';
  PTXDBNode(Buffer)^.MetaData[ 4] := '';
  PTXDBNode(Buffer)^.MetaData[ 5] := '';
  PTXDBNode(Buffer)^.MetaData[ 6] := '';
  PTXDBNode(Buffer)^.MetaData[ 7] := '';
  PTXDBNode(Buffer)^.MetaData[ 8] := '';
  PTXDBNode(Buffer)^.MetaData[ 9] := '';
  PTXDBNode(Buffer)^.MetaData[10] := '';
  PTXDBNode(Buffer)^.MetaData[11] := '';
  PTXDBNode(Buffer)^.MetaData[12] := '';
  PTXDBNode(Buffer)^.MetaData[13] := '';
end;

function TXDBTable.GetFieldData(Field: TField; Buffer: Pointer): Boolean;
var i,StartID,EndID,ds:integer;
    fn,DataStr,str:string;
begin
  DataStr := '';
  str := '';
  fn  := Field.FieldName;
  ds  := Field.DataSize-1;
  for i := 1 to 13 do
    if(PTXDBNODE(self.ActiveBuffer)^.MetaData[i] <> '')then
      DataStr := DataStr + PTXDBNODE(ActiveBuffer)^.MetaData[i];
  //------------------------------------------------------------
  StartID := GetFieldDataStartIDInDataStr(Field.FieldName);
  EndID   := StartID+ds-1;
  if(trim(DataStr) <> '')then
  if(Length(DataStr) >= EndID)then
    begin
      for i := StartID to EndID do str := str+DataStr[i];
      //------------------------------------------------------------
      StrLCopy(Buffer,PChar(trim(str)),Length(trim(str)));
      Result := PChar(Buffer)^ <> #0;
    end//if...end!!
  else Result := FALSE;
end;

procedure TXDBTable.SetFieldData(Field: TField; Buffer: Pointer);
var i,j,id,StartID,EndID:integer;
    DataStr,tmpDataStr,tmpStr:string;
begin
  tmpDataStr := ''; DataStr := '';
  for i := 1 to 13 do
    if(PTXDBNODE(self.ActiveBuffer)^.MetaData[i] <> '')then
      tmpDataStr := DataStr+PTXDBNODE(self.ActiveBuffer)^.MetaData[i];
  DataStr := tmpDataStr;
  tmpStr  := PChar(Buffer);
  //-----------------------------------------
  while(Length(tmpStr) < Field.DataSize-1)do
    tmpStr := tmpStr + ' ';
  //-----------------------------------------
  if(trim(DataStr) = '')then
    DataStr := DataStr+tmpStr
  else
    begin
      StartID := GetFieldDataStartIDInDataStr(Field.FieldName);
      EndID   := StartID+Field.DataSize-1;
      if(Length(DataStr) >= EndID)then
        begin//ƿJP@Field
          id := 1;
          for j := StartID to EndID do
            if(tmpStr[id] <> #0)then
              begin
                DataStr[j] := tmpStr[id];
                id := id+1;
              end;//for...j...end!!
        end//if...end!!
      else DataStr := DataStr+tmpStr;
    end;
  PutDataStrToPageArray(PTXDBNODE(self.ActiveBuffer)^,DataStr,-1);
  DataEvent(deFieldChange, Longint(Field));
end;

procedure TXDBTable.InternalFirst;
begin
  if(self.FData = nil)then Exit;
  self.FData.First;
  self.FCurRec := self.FData.GetBookMark;
end;

procedure TXDBTable.InternalLast;
begin
  if(self.FData = nil)then Exit;
  self.FData.Last;
  self.FCurRec := self.FData.GetBookMark;
end;

procedure TXDBTable.InternalPost;
var i:integer;
    IsInsertData:boolean;
    fdStr,DataStr:string;
begin
  if(self.FData = nil)then Exit;
  if(self.State = dsInsert)then
    begin
      IsInsertData := TRUE;
      self.FData.Insert;
    end;//if...end!!
  //----------------------------------
  if(self.State = dsEdit)then
    self.FData.Edit;
  //----------------------------------------------------
  for i := 0 to self.FieldCount-1 do
    begin
      fdStr   := self.Fields[i].FieldName;
      DataStr := self.Fields[i].AsString;
      self.FData.FieldByName(fdStr).AsString := DataStr;
    end;//for...i...end!!
  //----------------------------------------------------
  if(self.FData.Post = TRUE)
    and(IsInsertData = TRUE)then
    self.FCurRec := self.FData.GetBookMark;
end;

procedure TXDBTable.InternalAddRecord(Buffer: Pointer; Append: Boolean);
var i,j,StartId,EndID:integer;
    DataStr,tmpStr:string;
begin
  if(self.FData = nil)then Exit;
  //Keep !!
  if(Append = TRUE)then InternalLast;
  self.FData.Insert;
  for i := 1 to 13 do
    if(PTXDBNode(Buffer)^.MetaData[i] <> '')then
      DataStr := DataStr + PTXDBNode(Buffer)^.MetaData[i];
  //------------------------------------------------------
  for i := 0 to self.FieldCount-1 do
    begin
      StartID := self.GetFieldDataStartIDInDataStr(self.Fields[i].FieldName);
      EndID   := StartID+self.Fields[i].DataSize-1;
      tmpStr := '';
      for j := StartID to EndID do
        tmpStr := tmpStr+DataStr[j];
      self.FData.FieldByName(self.Fields[i].FieldName).AsString := tmpStr;
    end;//for...i...end!!
  self.FData.Post;
end;

procedure TXDBTable.InternalDelete;
begin
  if(self.FData = nil)then Exit;
  self.FData.GotoBookMark(self.FCurRec);
  self.FData.Delete;
  self.FCurRec := self.FData.RecDataSet.GetPhysicalBookMark;
  self.FData.GotoBookMark(self.FCurRec);
end;

function TXDBTable.GetRecNo: Longint;
begin
  if(self.FData = nil)then Exit;
  UpdateCursorPos;
  self.FCurRec := self.FData.GetBookMark;
end;

procedure TXDBTable.SetRecNo(Value: Integer);
begin
  if(self.FData = nil)then Exit;
  self.FCurRec := Value;
  Resync([]);
end;

function TXDBTable.FindData(const KeyFields,KeyValues: array of Variant):boolean;
var ftCount,ValueCount,i:integer;
    KeyValue:TStringList;
    tmpstr:string;
begin
  Result := FALSE;
  if(self.FData = nil)then Exit;
  if(self.FData.Active = FALSE)then Exit;
  //-------------------------------------
  ftCount    := High(KeyFields);
  ValueCount := High(KeyValues);
  if(ftCount <> ValueCount)then Exit;
  try
    KeyValue := TStringList.Create;
    KeyValue.Clear;
    if(ftCount = 0)then
      begin
        tmpstr := KeyValues[0];
        KeyValue.Add(tmpstr);
        if(self.FData.LocateByKeyValues(KeyValue) = TRUE)then
          result := TRUE;
      end//if...end!!
    else
      begin
        for i := 0 to ftCount-1 do
          begin
            tmpstr := KeyValues[i];
            KeyValue.Add(tmpstr);
          end;//for...i...end!!
        if(self.FData.LocateByKeyValues(KeyValue) = TRUE)then
          result := TRUE;
      end;//else...end!!
  finally
    KeyValue.Clear;
    KeyValue.Free;
  end;//try...end!!    
end;

function TXDBTable.GetRecordCount: Integer;
begin
  if(self.FData = nil)then Exit;
  Result := self.FData.RecordCount;
end;

procedure TXDBTable.ApplyUpdates;
begin
  //
end;

function TXDBTable.GetCanModify: Boolean;
begin
  if(self.FData = nil)then Exit;
  result := not self.FReadOnly;
end;

procedure TXDBTable.SetFReadOnly(const Value: boolean);
begin
  self.FReadOnly := Value;
end;

function TXDBTable.GetFieldDataStartIDInDataStr(FdName:string): integer;
var i,StrStartID:integer;
begin
  result := -1;
  StrStartID := 1;   
  for i := 0 to self.FieldCount-1 do
    begin
      if(self.Fields[i].FieldKind = fkData)then
      if(i = 0)and(self.Fields[i].FieldName = FdName)then
        begin
          result := 1;
          Break;
        end//if...end!!
      else
        if(self.Fields[i].FieldName = FdName)then
          begin
            result := StrStartID;
            Break;              
          end//if...end!!
        else
          StrStartID := StrStartID
                       +self.FData.FieldDataSize(self.Fields[i].FieldName);
    end;//for...i...end!!
end;

procedure TXDBTable.SetFCacheUpdate(const Value: boolean);
begin
  self.FCacheUpdate := Value;
end;

//DataSnap ( MIDAS ) Support !!
function TXDBTable.PSUpdateRecord(UpdateKind: TUpdateKind;
  Delta: TDataSet): Boolean;

var i,j,recNo:integer;
    fname:string;
    keyStr,dataStr:string;
begin
  result := FALSE;
  Delta.First;
  case UpdateKind of
    ukInsert
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             self.Insert;
             for j := 0 to Delta.FieldCount-1 do
               begin
                 fname   := Delta.Fields[j].FieldName;
                 dataStr := Delta.FieldByName(fname).AsString;
                 //debug !! ShowMessage( 'Field : '+fname
                 //debug !!             +#10#13
                 //debug !!             +'Data  : '+dataStr);
                 //if(trim(dataStr) <> '')then
                 self.FieldByName(fname).AsString := dataStr;
               end;//for...j...end!!
             self.Post;
             Delta.Next;
           end;//for...i...end!!
         result := TRUE;
       end;
    ukModify
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             fname   := Delta.Fields[0].FieldName;
             keyStr  := Delta.FieldByName(fname).AsString;
             if(trim(keyStr) <> '')then
               self.FindData([fname],[keyStr])
             else
               begin
                 self.Edit;
                 for j := 0 to Delta.FieldCount-1 do
                   begin
                     fname   := Delta.Fields[j].FieldName;
                     dataStr := Delta.FieldByName(fname).AsString;
                     //debug !! ShowMessage( 'Field : '+fname
                     //debug !!             +#10#13
                     //debug !!             +'Data  : '+dataStr);
                     if(trim(dataStr) <> '')then
                       self.FieldByName(fname).AsString := dataStr;
                   end;//for...j...end!!
                 self.Post;
               end;//else...end!!
             Delta.Next;
           end;//for...i...end!!
         result := TRUE;
       end;
    ukDelete
      :begin
         for i := 0 to Delta.RecordCount-1 do
           begin
             fname   := Delta.Fields[0].FieldName;
             keyStr  := Delta.FieldByName(fname).AsString;
             if(trim(keyStr) <> '')then
             if(self.FindData([fname],[keyStr]) = TRUE)then
               self.Delete;
             Delta.Next;
           end;//for...i...end!!
         result := TRUE;
       end;
  end;//case...end!!
end;

//TXDBFileName.
procedure TXDBFileName.Edit;
var FileOpen :TOpenDialog;
    tmpFileDB:TXDBTable;
    str,NameStr:string;
    i,id:integer;
begin
  tmpFileDB := TXDBTable(self.GetComponent(0));
  FileOpen  := TOpenDialog.Create(Nil);
  FileOpen.Filename := GetValue;
  FileOpen.Filter := 'AspFileDB Files (*.XDB)|*.XDB|All Files (*.*)|*.*';
  FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];
  try
    if(FileOpen.Execute = TRUE)then
    if(trim(FileOpen.Filename) <> '')then
      begin
        //tmpFileDB.SchemaFileName := '';
        tmpFileDB.FFileName := FileOpen.Filename;
        SetValue(FileOpen.Filename);
      end;//if...end!!
  finally
    FileOpen.Free;
    tmpFileDB := nil;
  end;
end;

function TXDBFileName.GetAttributes: TPropertyAttributes;
begin
  result := [paDialog, paRevertable];
end;

procedure TXDBTable.InternalRefresh;
begin
  IsInRefreshState := TRUE;
end;

procedure TXDBTable.InternalInsert;
begin
  self.IsInInsertState := TRUE;
end;

procedure TXDBTable.InternalCancel;
begin
  self.IsInInsertState := FALSE;
  self.IsInEditState   := FALSE;
end;

procedure TXDBTable.InternalEdit;
begin
  self.IsInEditState := TRUE;
end;

end.
